.\" @(#)trans.man 1.2 91/02/21
.TH TRANS 6 "18 February 1991"
.SH NAME
trans \- a utility to print a transcript from reve game recordings.
.SH SYNOPSIS
.B "trans
[
.B \-b
.I string
] [
.B \-w
.I string
] [
.B \-r
.I string
] [
.B \-d
.I string
] [
.B \-c
.I string
] [
.B \-g
.I string
] [
.B \-t
.I string
] [
.B \-s
.I string
] [
.B \-p
.I string
] [
.B \-l
.I string
]
.LP
.B trans
.B \-h
.SH DESCRIPTION
.I Trans
will take a game record produced by
.I reve
(see manual pages for reve(6)), and produce a PostScript file with a
transcript of the game, i.e. it will draw a board and show the moves made,
numbered in sequence.
.LP
The options allow you to specify source and destination files, printed size
of the board, and information about the game. Strings containing white space
or special characters need to be quoted. Unused options are filled with a
default value.
.LP
The resulting file can be sent to any PostScript printer.
.SH OPTIONS
.TP
.BI \-b " [ string ] "
Black player name. The default is an empty string.
.TP
.BI \-w " [ string ] "
White player name. The default is an empty string.
.TP
.BI \-r " [ string ] "
The result of the game. The default is an empty string.
.TP
.BI \-d " [ string ] "
The date the game was played. The default is an empty string.
.TP
.BI \-c " [ string ] "
A comment line. The default is an empty string.
.TP
.BI \-g " [ string ] "
The name of the game transcript file. The default is "reve.game".
.TP
.BI \-t " [ string ] "
The name of the output file containing the Postscript file to be printed.
The default is "reve.trans.ps".
.TP
.BI \-s " factor "
The scaling factor for printed transcript. The default fills one letter size
page.
.TP
.BI \-p " [ string ] "
The place or occasion when the game was held. The default is an empty string.
.TP
.BI \-l " [ string ] "
The time limit or level for the game. The default is an empty string.
.TP
.B \-h
Display a help message.
.SH EXAMPLES
.TP
trans -g "../games/reve/reve.game" -t "/tmp/foo.ps"
.TP
trans -b valerie -w reve -r "32-32" -d "Feb 17, 1991"
.TP
trans -c "I won!" -l "5 Minutes" -p "at work" -s "0.5"
.TP
trans -h
.SH BUGS
See the TODO file for the list of known problems.
.SH AUTHOR
.br
Valerie Haecky		vmh@Eng.Sun.COM
